{- 2010-09-17 haskell syntax tools -}

module HsSyntax where

import Language.Haskell.Exts.Syntax

noLoc :: SrcLoc
noLoc = SrcLoc "" 0 0

qualIO :: String -> QName
qualIO s = Qual (ModuleName "IO") (Ident s)

mkModule :: [Decl] -> Module
mkModule hs = Module noLoc main_mod pragmas warning exports imports decls where
  pragmas = [ LanguagePragma noLoc
    [ Ident "NoImplicitPrelude"
    ]]
  warning = Nothing
  exports = Nothing
  imports = 
    [ ImportDecl 
      { importLoc       = noLoc 
      , importModule    = ModuleName "System.IO" 
      , importQualified = True 
      , importSrc       = False 
      , importPkg       = Nothing
      , importAs        = Just $ ModuleName "IO"
      , importSpecs     = Nothing
      } 
    ]
  decls   = hs ++ 
    [ TypeSig noLoc [ main_name ] io
    , FunBind [ Match noLoc main_name [] Nothing (UnGuardedRhs rhs) (BDecls []) ]
    ] where rhs  = Var (qualIO "putStrLn") `App` Lit (String "Hello, world!")
            io   = TyCon (qualIO "IO") `TyApp` unit_tycon
         
{- this is already predefined as unit_con
hsDummyExp :: HsExp
hsDummyExp = HsCon $ Special $ HsUnitCon  -- Haskell's '()'
-}